unit Amend;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TAmendForm = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    OrgBitmap: TBitmap;
  end;

var
  AmendForm: TAmendForm;

implementation

uses Frame;

{$R *.DFM}

procedure TAmendForm.FormShow(Sender: TObject);
var
  ALeft, ATop: Integer;
begin
  ALeft := FrameForm.Left + FrameForm.Width + 10;
  if (ALeft < 0) or (ALeft > Screen.Width - Width) then
    ALeft := (Screen.Width - Width) div 2;

  ATop := FrameForm.Top + (FrameForm.Height - Height) div 2;
  if (ATop < 0) or (ATop > Screen.Height - Height) then
    ATop := (Screen.Height - Height) div 2;

  Left := ALeft;
  Top := ATop;

  OrgBitmap := TBitmap.Create;
  OrgBitmap.Assign(FrameForm.TurboImage1.Picture.Bitmap);
  FrameForm.TurboImage1.Automatic(TrackBar1.Position - 1);
end;

procedure TAmendForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  OrgBitmap.Free;
end;

procedure TAmendForm.Button2Click(Sender: TObject);
begin
  FrameForm.TurboImage1.Picture.Assign(OrgBitmap);
end;

procedure TAmendForm.TrackBar1Change(Sender: TObject);
var
  Amend: Integer;
begin
  Amend := TrackBar1.Position;
  Label1.Caption := '摜̕␳x ( ' + IntToStr(Amend) + ' )';
  FrameForm.TurboImage1.Picture.Assign(OrgBitmap);
  FrameForm.TurboImage1.Automatic(Amend - 1);
end;

end.
