program Capture;

uses
  Windows,
  Messages,
  Forms,
  Frame in 'Frame.pas' {FrameForm},
  View in 'View.pas' {ViewForm},
  Setting in 'Setting.pas' {SettingForm},
  Amend in 'Amend.pas' {AmendForm},
  Preview in 'Preview.pas' {PreviewForm};

const
  WM_CaptureKun = WM_APP + $256;

{$R *.RES}

var
  MutexName: String;
  hMutex: THandle;
begin
  MutexName := 'CaptureKun Copyright(C) 2017 seizo';
  hMutex:= OpenMutex(MUTEX_ALL_ACCESS, False, PChar(MutexName));
  if hMutex <> 0 then
  begin
    CloseHandle(hMutex);
    SendMessage(HWND_BROADCAST, WM_NULL, 0, WM_CaptureKun);
  end
  else
  begin
    hMutex:= CreateMutex(Nil, False, PChar(MutexName));

    Application.Initialize;
    Application.CreateForm(TFrameForm, FrameForm);
  Application.Run;

    ReleaseMutex(hMutex);
  end;
end.
