unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, ShellAPI, Param, Clipbrd, jpeg, FileCtrl, TurboImg, GIFImage,
  DropSource, DropBMPSource;

const
  WM_CaptureKun = WM_APP + $256;
  VDay          = 1.0;            // ̒ TDateTime ^̒lƂĕ\
  VHour         = VDay / 24;      // ꎞԂ̒ TDateTime ^̒lƂĕ\
  VMinute       = VHour / 60;     // ꕪ̒ TDateTime ^̒lƂĕ\
  VSecond       = VMinute / 60;   // b̒ TDateTime ^̒lƂĕ\
  VMilliSecond  = VSecond / 1000; // ~b̒ TDateTime ^̒lƂĕ\
  VDaySecond    = 24 * 60 * 60;   // ̕b

var
  CF_JFIF: Word;
  CF_GIF: Word;

type
  TFrameForm = class(TForm)
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    Parameter1: TParameter;
    N6: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    PopupMenu2: TPopupMenu;
    Close1: TMenuItem;
    Bitmap1: TMenuItem;
    JPEG1: TMenuItem;
    Metafile1: TMenuItem;
    N7: TMenuItem;
    Bitmap2: TMenuItem;
    JPEG2: TMenuItem;
    Metafile2: TMenuItem;
    N8: TMenuItem;
    Help2: TMenuItem;
    About2: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    Timer1: TTimer;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N19: TMenuItem;
    N18: TMenuItem;
    N22: TMenuItem;
    TurboImage1: TTurboImage;
    GIF1: TMenuItem;
    GIF2: TMenuItem;
    N2561: TMenuItem;
    DropBMPSource1: TDropBMPSource;
    N20: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    N21: TMenuItem;
    T1: TMenuItem;
    PrintPreview1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure About2Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure Bitmap1Click(Sender: TObject);
    procedure JPEG1Click(Sender: TObject);
    procedure Metafile1Click(Sender: TObject);
    procedure N19Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure N18Click(Sender: TObject);
    procedure Bitmap2Click(Sender: TObject);
    procedure JPEG2Click(Sender: TObject);
    procedure Metafile2Click(Sender: TObject);
    procedure N22Click(Sender: TObject);
    procedure GIF1Click(Sender: TObject);
    procedure GIF2Click(Sender: TObject);
    procedure N2561Click(Sender: TObject);
    procedure TurboImage1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TurboImage1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure T1Click(Sender: TObject);
    procedure PrintPreview1Click(Sender: TObject);
  private
    { Private 錾 }
    DragPoint: TPoint;
    uTaskBarRecreate: UINT;
    procedure CreateTaskBarIcon;
    procedure DeleteTaskBarIcon;
    function Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
  protected
    { protected 錾 }
    procedure WndProc(var Msg: TMessage); override;
    procedure WMHotKey(var Msg: TMessage); message WM_HOTKEY;
  public
    { Public 錾 }
    CaptureTime: TDateTime; // Lv`[s
    Resident: Boolean; // ^XNg[ɏ풓B
    Notice: Boolean; // Lv`[摜ۑɂ̃t@C\B
    AutoSave: Boolean; // IɃLv`[摜ۑB
    DefaultGraphic: Integer; // Lv`[摜ۑ̃fBtHg̉摜̎
    HotKeyC: Integer; // Lv`[JnpO[ozbgL[
    HotKeyA: Integer; // ANeBuEBhE摜ۑpO[ozbgL[
    HotKeyS: Integer; // SXN[摜ۑpO[ozbgL[
    HotKeyC_ID: ATOM; // Lv`[JnpO[ozbgL[ ID
    HotKeyA_ID: ATOM; // ANeBuEBhE摜ۑpO[ozbgL[ ID
    HotKeyS_ID: ATOM; // SXN[摜ۑpO[ozbgL[ ID
    ReservedStart: TDateTime; // Lv`[\Jn
    ReservedStep: Integer; // Lv`[\̕bPʂ̕ۑԊu
    ReservedStop: TDateTime; // Lv`[\I
    EveryDay: Boolean; // ԑтɃLv`[\sB
    ReservedStart_S: String; // Lv`[\Jn(x[X)
    ReservedStop_S: String; // Lv`[\I(x[X)
    JPEGQuality: Integer; // JPEG `ŕۑꍇ̉掿߂l(1`100)
    GIFOption: Boolean; // GIF ŕۑRs[ꍇɁAɌFB
    ActiveWindowRect: TRect; // Lv`[s̃ANeBuEBhE͈̔
    CaptureData: String; // Lv`[摜ۑpfBNg
    procedure GetCaptureTime;
    procedure GetActiveWindowRect;
    procedure AddHotKey(HotKeyType: String);
    procedure DeleteHotKey(HotKeyType: String);
    procedure SaveFormImage(CTime: TDateTime; GType: Integer);
    procedure SaveScreenImage(CTime: TDateTime; SRect: TRect; GType: Integer);
    procedure CopyFormImage(GType: Integer);
    procedure InitTimer; // ^C}[̐ݒB
    function DoCapture: Boolean;
  end;

var
  FrameForm: TFrameForm;

implementation

uses View, Setting, Amend, Preview;

{$R *.DFM}

{ ݂̎擾B}

procedure TFrameForm.GetCaptureTime;
begin
{
  CaptureTime := FormatDateTime('yyyymmddhhnnss', Now); // 'yyyy/mm/dd hh:nn:ss'
}
  CaptureTime := Now;
end;

{ ݂̃ANeBuEBhE͈̔͂擾B}

procedure TFrameForm.GetActiveWindowRect;
var
  hTargetWnd: HWND;
begin
  hTargetWnd := GetForegroundWindow;
  GetWindowRect(hTargetWnd, ActiveWindowRect);
end;

{ zbgL[Vɓo^葱łB}

procedure TFrameForm.AddHotKey(HotKeyType: String);
var
  Hot: Boolean;
  Key, Shift: Integer;

  function KeyType(GHotKey: Integer): String;
  begin
    Result := '';
    Key := GHotKey and $0000FFFF;
    Shift := GHotKey shr 16;
    if (Shift and MOD_CONTROL) <> 0 then Result := Result + 'Ctrl + ';
    if (Shift and MOD_SHIFT) <> 0 then Result := Result + 'Shift + ';
    if (Shift and MOD_ALT) <> 0 then Result := Result + 'Alt + ';
    if (Shift and MOD_WIN) <> 0 then Result := Result + 'Win + ';
    if Key = 0 then Result := Copy(Result, 1, Length(Result) - 3)
    else if (Key >= VK_F1) and (Key <= VK_F12) then Result := Result + 'F' + IntToStr(Key - VK_F1 + 1)
    else Result := Result + Chr(Key);
  end;

begin
  if Pos('C', HotKeyType) <> 0 then
  begin
    if (HotKeyC_ID = 0) and (HotKeyC <> 0) then
    begin
      Hot := False;
      // ʂӂ̒l炢zbgL[ ID ƂB
      HotKeyC_ID := GlobalAddAtom('CaptureKun_HotKeyC_seizo');
      if HotKeyC_ID <> 0 then
      begin
        // zbgL[̓o^
        if RegisterHotKey(Handle, HotKeyC_ID, HotKeyC shr 16, HotKeyC and $0000FFFF) then
          Hot := True;
      end;
      if Hot = False then
      begin
        ShowMessage(#13#10 + KeyType(HotKeyC) + '  L[̑gݍ킹́A' +  #13#10 + #13#10 +
                    'zbgL[Ƃēo^o܂B' + #13#10 + #13#10 +
                    '̃AvŎgpĂ\܂B' + #13#10 + #13#10 +
                    '̃L[̑gݍ킹IĉB' + #13#10);
        HotKeyC := 0;
      end;
    end;
  end;

  if Pos('A', HotKeyType) <> 0 then
  begin
    if (HotKeyA_ID = 0) and (HotKeyA <> 0) then
    begin
      Hot := False;
      // ʂӂ̒l炢zbgL[ ID ƂB
      HotKeyA_ID := GlobalAddAtom('CaptureKun_HotKeyA_seizo');
      if HotKeyA_ID <> 0 then
      begin
        // zbgL[̓o^
        if RegisterHotKey(Handle, HotKeyA_ID, HotKeyA shr 16, HotKeyA and $0000FFFF) then
          Hot := True;
      end;
      if Hot = False then
      begin
        ShowMessage(#13#10 + KeyType(HotKeyA) + '  L[̑gݍ킹́A' + #13#10 + #13#10 +
                    'zbgL[Ƃēo^o܂B' + #13#10 + #13#10 +
                    '̃AvŎgpĂ\܂B' + #13#10 + #13#10 +
                    '̃L[̑gݍ킹IĉB' + #13#10);
        HotKeyA := 0;
      end;
    end;
  end;

  if Pos('S', HotKeyType) <> 0 then
  begin
    if (HotKeyS_ID = 0) and (HotKeyS <> 0) then
    begin
      Hot := False;
      // ʂӂ̒l炢zbgL[ ID ƂB
      HotKeyS_ID := GlobalAddAtom('CaptureKun_HotKeyS_seizo');
      if HotKeyS_ID <> 0 then
      begin
        // zbgL[̓o^
        if RegisterHotKey(Handle, HotKeyS_ID, HotKeyS shr 16, HotKeyS and $0000FFFF) then
          Hot := True;
      end;
      if Hot = False then
      begin
        ShowMessage(#13#10 + KeyType(HotKeyS) + '  L[̑gݍ킹́A' +  #13#10 + #13#10 +
                    'zbgL[Ƃēo^o܂B' + #13#10 + #13#10 +
                    '̃AvŎgpĂ\܂B' + #13#10 + #13#10 +
                    '̃L[̑gݍ킹IĉB' + #13#10);
        HotKeyS := 0;
      end;
    end;
  end;
end;

{ o^ĂzbgL[葱łB}

procedure TFrameForm.DeleteHotKey(HotKeyType: String);
begin
  if Pos('C', HotKeyType) <> 0 then
  begin
    if HotKeyC_ID <> 0 then
    begin
      // zbgL[̓o^
      UnRegisterHotKey(Handle, HotKeyC_ID);
      // AgɊ֘AtĂ镶Age[u폜B
      DeleteAtom(HotKeyC_ID);
      HotKeyC_ID := 0;
    end;
  end;

  if Pos('A', HotKeyType) <> 0 then
  begin
    if HotKeyA_ID <> 0 then
    begin
      // zbgL[̓o^
      UnRegisterHotKey(Handle, HotKeyA_ID);
      // AgɊ֘AtĂ镶Age[u폜B
      DeleteAtom(HotKeyA_ID);
      HotKeyA_ID := 0;
    end;
  end;

  if Pos('S', HotKeyType) <> 0 then
  begin
    if HotKeyA_ID <> 0 then
    begin
      // zbgL[̓o^
      UnRegisterHotKey(Handle, HotKeyS_ID);
      // AgɊ֘AtĂ镶Age[u폜B
      DeleteAtom(HotKeyS_ID);
      HotKeyS_ID := 0;
    end;
  end;
end;

{ ݁AFrameForm ɕ\ĂC[Wۑ葱łB}

procedure TFrameForm.SaveFormImage(CTime: TDateTime; GType: Integer);
var
  FileName: TFileName;
  R: TRect;
  Bmp: TBitmap;
  Jpeg: TJPEGImage;
  Gif: TGIFImage;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  FileName := CaptureData + FormatDateTime('yyyymmddhhnnss', CTime);

  if GType = 0 then // Bitmap
  begin
    FileName := FileName + '.bmp';
    TurboImage1.Picture.SaveToFile(FileName);
  end
  else if GType = 1 then // JPEG
  begin
    FileName := FileName + '.jpg';
    Jpeg := TJPEGImage.Create;
    Jpeg.CompressionQuality := JPEGQuality; // 1`100
    try
      Jpeg.Assign(TurboImage1.Picture.Bitmap);
      Jpeg.SaveToFile(Filename);
    finally
      Jpeg.Free;
    end;
  end
  else if GType = 2 then // GIF
  begin
    FileName := FileName + '.gif';
    Gif := TGIFImage.Create;
    try
      if GIFOption and (TurboImage1.Picture.Bitmap.PixelFormat <> pf8bit) then
      begin
        Bmp := TBitmap.Create;
        try
          Bmp.Assign(TurboImage1.Picture.Bitmap);
          TurboImage1.Reduce(rdcOctree);
          Gif.Assign(TurboImage1.Picture.Bitmap);
          Gif.SaveToFile(Filename);
        finally
          TurboImage1.Picture.Bitmap.Assign(Bmp);
          Bmp.Free;
        end;
      end
      else
      begin
        Gif.Assign(TurboImage1.Picture.Bitmap);
        Gif.SaveToFile(Filename);
      end;
    finally
      Gif.Free;
    end;
  end
  else if GType = 3 then // Metafile
  begin
    R := Rect(0, 0, TurboImage1.Picture.Width, TurboImage1.Picture.Height);
    FileName := FileName + '.emf';
    Mf := TMetafile.Create;
    Mf.Enhanced := True;
    try
      Mf.Width := TurboImage1.Picture.Width;
      Mf.Height := TurboImage1.Picture.Height;
      MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
      try
        MfCanvas.StretchDraw(R, TurboImage1.Picture.Graphic);
      finally
        MfCanvas.Free;
      end;
      Mf.SaveToFile(Filename);
    finally
      Mf.Free;
    end;
  end;

  if CanFocus and Notice then
    ShowMessage(#13#10 + FileName + #13#10 + #13#10 + 'ɃLv`[C[Wۑ܂B');
end;

{ ݁AScreen ɕ\ĂC[Wۑ葱łB}

procedure TFrameForm.SaveScreenImage(CTime: TDateTime; SRect: TRect; GType: Integer);
var
  FileName: TFileName;
  W, H: Integer;
  DRect: TRect;
  DC: HDC;
  DBitmap: TBitmap;
  Jpeg: TJPEGImage;
  Gif: TGIFImage;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  FileName := CaptureData + FormatDateTime('yyyymmddhhnnss', CTime);

  W := SRect.Right - SRect.Left + 1;
  H := SRect.Bottom - SRect.Top + 1;
  DRect := Rect(0, 0, W, H);

  DBitmap := TBitmap.Create;
  try
    DBitmap.Width := W;
    DBitmap.Height := H;

    DC := GetDC(0);
    BitBlt(DBitmap.Canvas.Handle, 0, 0, W, H, DC, SRect.Left, SRect.Top, SRCCOPY);
    ReleaseDC(0, DC);

    if GType = 0 then // Bitmap
    begin
      FileName := FileName + '.bmp';
      DBitmap.SaveToFile(FileName);
    end
    else if GType = 1 then // JPEG
    begin
      FileName := FileName + '.jpg';
      Jpeg := TJPEGImage.Create;
      Jpeg.CompressionQuality := JPEGQuality; // 1`100
      try
        Jpeg.Assign(DBitmap);
        Jpeg.SaveToFile(Filename);
      finally
        Jpeg.Free;
      end;
    end
    else if GType = 2 then // GIF
    begin
      FileName := FileName + '.gif';
      Gif := TGIFImage.Create;
      try
        if GIFOption and (DBitmap.PixelFormat <> pf8bit) then
        begin
          TurboImage1.Picture.Assign(DBitmap);
          try
            TurboImage1.Reduce(rdcOctree);
            Gif.Assign(TurboImage1.Picture.Bitmap);
          finally
            TurboImage1.Picture := Nil;
            Gif.SaveToFile(Filename);
          end;
        end
        else
        begin
          Gif.Assign(DBitmap);
          Gif.SaveToFile(Filename);
        end;
      finally
        Gif.Free;
      end;
    end
    else if GType = 3 then // Metafile
    begin
      FileName := FileName + '.emf';
      Mf := TMetafile.Create;
      Mf.Enhanced := True;
      try
        Mf.Width := W;
        Mf.Height := H;
        MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
        try
          MfCanvas.StretchDraw(DRect, DBitmap);
        finally
          MfCanvas.Free;
        end;
        Mf.SaveToFile(Filename);
      finally
        Mf.Free;
      end;
    end;
  finally
    DBitmap.Free;
  end;

  if CanFocus and Notice then
    ShowMessage(#13#10 + FileName + #13#10 + #13#10 + 'ɃLv`[C[Wۑ܂B');
end;

{ ݁AFrameForm ɕ\ĂC[WNbv{[hփRs[葱łB}

procedure TFrameForm.CopyFormImage(GType: Integer);
var
  R: TRect;
  Bmp: TBitmap;
  Jpeg: TJPEGImage;
  Gif: TGIFImage;
  MemStream: TMemoryStream;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  if GType = 0 then // Bitmap
    Clipboard.Assign(TurboImage1.Picture.Bitmap)
  else if GType = 1 then // JPEG
  begin
    Jpeg := TJPEGImage.Create;
    Jpeg.CompressionQuality := JPEGQuality; // 1`100
    try
      Jpeg.Assign(TurboImage1.Picture.Bitmap);
      MemStream := TMemoryStream.Create;
      try
        Jpeg.SaveToStream(MemStream);
        Stream2Clipboard(CF_JFIF, MemStream);
      finally
        MemStream.Free;
      end;
    finally
      Jpeg.Free;
    end;
  end
  else if GType = 2 then // GIF
  begin
    Gif := TGIFImage.Create;
    try
      if GIFOption and (TurboImage1.Picture.Bitmap.PixelFormat <> pf8bit) then
      begin
        Bmp := TBitmap.Create;
        try
          Bmp.Assign(TurboImage1.Picture.Bitmap);
          TurboImage1.Reduce(rdcOctree);
          Gif.Assign(TurboImage1.Picture.Bitmap);
        finally
          TurboImage1.Picture.Bitmap.Assign(Bmp);
          Bmp.Free;
        end;
      end
      else
        Gif.Assign(TurboImage1.Picture.Bitmap);
      MemStream := TMemoryStream.Create;
      try
        Gif.SaveToStream(MemStream);
        Stream2Clipboard(CF_GIF, MemStream);
      finally
        MemStream.Free;
      end;
    finally
      Gif.Free;
    end;
  end
  else if GType = 3 then // Metafile
  begin
    R := Rect(0, 0, TurboImage1.Picture.Width, TurboImage1.Picture.Height);
    Mf := TMetafile.Create;
    Mf.Enhanced := True;
    try
      Mf.Width := TurboImage1.Picture.Width;
      Mf.Height := TurboImage1.Picture.Height;
      MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
      try
        MfCanvas.StretchDraw(R, TurboImage1.Picture.Graphic);
      finally
        MfCanvas.Free;
      end;
      Clipboard.Assign(Mf);
    finally
      Mf.Free;
    end;
  end;
end;

{ ^C}[̏ݒ葱łB}

procedure TFrameForm.InitTimer;
var
  RTerm: Double;
  RNow: TDateTime;
begin
  Timer1.Tag := 0;
  Timer1.Enabled := False;

  if EveryDay then // ԑтɃLv`[\sB
  begin
    RNow := Now;
    RTerm := Int(ReservedStop) - Int(ReservedStart); // Lv`[\̊Ԋu
    ReservedStart := Int(RNow) + (ReservedStart - Int(ReservedStart));
    ReservedStop := Int(RNow) + RTerm + (ReservedStop - Int(ReservedStop));
  end;

  Timer1.Interval := 1000; // ܂A1bɍŏ̃CxgB
  Timer1.Enabled := True; // Timer1 N
end;

{ ACRgCɓo^||ł̓CACRgp }

procedure TFrameForm.CreateTaskBarIcon;
var
  NotifyData: TNotifyIconData;
begin
  with NotifyData do
  begin
    cbSize := SizeOf(TNotifyIconData);
    Wnd := Handle;
    uID := 0;
    uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
    uCallbackMessage := WM_CaptureKun; // Ǝɒ`
    hIcon := Application.Icon.Handle;
    szTip := 'CaptureN';
  end;
  Shell_NotifyIcon(NIM_ADD, @NotifyData);
end;

{ ACR폜 }

procedure TFrameForm.DeleteTaskBarIcon;
var
  NotifyData: TNotifyIconData;
begin
  with NotifyData do
  begin
    cbSize := SizeOf(TNotifyIconData);
    Wnd := Handle;
    uID := 0;
  end;
  Shell_NotifyIcon(NIM_DELETE, @NotifyData);
end;

function TFrameForm.Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
var
  Data: THandle;
  DataPtr: Pointer;
begin
  Result := False;
  if MemStream.Size = 0 then
    Exit;
  Data := GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, MemStream.Size);
  try
    DataPtr := GlobalLock(Data);
    try
      MemStream.Position := 0;
      MemStream.ReadBuffer(DataPtr^, MemStream.Size);
      MemStream.Position := 0;
    finally
      GlobalUnlock(Data);
    end;
    Clipboard.SetAsHandle(Format, Data);
  except
    GlobalFree(Data);
    raise;
  end;
  Result := True;
end;

{ ^XNgCɗWM_CaptureKunbZ[WM }

procedure TFrameForm.WndProc(var Msg: TMessage);
var
  ps: TPoint;
begin
  with Msg do
    if Msg = WM_CaptureKun then
    begin
      case LParam of
        WM_LBUTTONDOWN:
          begin
            if DoCapture then
            begin
              Visible := True;
              ShowWindow(Application.Handle, SW_SHOW);
            end;
          end;
        WM_RBUTTONUP:
          begin
            GetCursorPos(ps);
            SetForegroundWindow(Handle);
            // tH[Ƀ|bvAbvj[ƂB
            PopupMenu1.Popup(ps.x, ps.y);
            PostMessage(Handle, WM_NULL, 0, 0);
          end;
        else
          // ^XNo[ړEč\zꂽꍇɏACRĐ
          if lParam = LongInt(uTaskBarRecreate) then
            CreateTaskBarIcon;
      end;
    end
    else if Msg = WM_NULL then
    begin
      if LParam = WM_CaptureKun then
      begin
        if Visible = False then
        begin
          if DoCapture then
          begin
            Visible := True;
            ShowWindow(Application.Handle, SW_SHOW);
          end;
        end;
      end;
    end
    else
      inherited;
end;

procedure TFrameForm.WMHotKey(var Msg: TMessage);
begin
  if Visible then
    Exit;

  if Msg.WParam = HotKeyC_ID then
  begin // Lv`[JnB
    if Visible = False then
    begin
      if DoCapture then
      begin
        Visible := True;
        ShowWindow(Application.Handle, SW_SHOW);
      end;
    end;
  end
  else if Msg.WParam = HotKeyA_ID then
  begin // ANeBuEBhẺ摜fBtHg̎ނ̉摜ŕۑB
    GetCaptureTime;
    GetActiveWindowRect;
    SaveScreenImage(CaptureTime, ActiveWindowRect, DefaultGraphic);
  end
  else if Msg.WParam = HotKeyS_ID then
  begin // SXN[̉摜fBtHg̎ނ̉摜ŕۑB
    GetCaptureTime;
    SaveScreenImage(CaptureTime, Rect(0, 0, Screen.Width - 1, Screen.Height - 1), DefaultGraphic);
  end;
end;

function TFrameForm.DoCapture: Boolean;
var
  mr: Integer;
begin
  TurboImage1.Picture := Nil; // Clear Image

  ViewForm := TViewForm.Create(Self);

  mr := ViewForm.ShowModal;

  ViewForm.Free;

  if mr = mrCancel then Result := False
  else Result := True;
end;

{ ^XNgCɏ풓BN̓gCɃACR\̂݁B}
{ V UtilWindow 쐬Au[hLXgbZ[Ŵ݂󂯎点B}

procedure TFrameForm.FormCreate(Sender: TObject);
var
  Dir: String;
begin
  {  }
  Resident := False; // ^XNg[ɏ풓B
  Notice := True; // Lv`[摜ۑɂ̃t@C\B
  AutoSave := False; // IɃLv`[摜ۑB
  DefaultGraphic := 1; // Lv`[摜ۑ̃fBtHg̉摜̎
  HotKeyC := 393287; // Lv`[JnpO[ozbgL[
  HotKeyA := 393281; // ANeBuEBhE摜ۑpO[ozbgL[
  HotKeyS := 393299; // SXN[摜ۑpO[ozbgL[
  HotKeyC_ID := 0; // Lv`[JnpO[ozbgL[ ID
  HotKeyA_ID := 0; // ANeBuEBhE摜ۑpO[ozbgL[ ID
  HotKeyS_ID := 0; // SXN[摜ۑpO[ozbgL[ ID
  ReservedStart_S := '2017/06/06 06:06:06'; // Lv`[\Jn(x[X)
  ReservedStart := StrToDateTime(ReservedStart_S); // Lv`[\Jn
  ReservedStep := 60; // Lv`[\̕bPʂ̕ۑԊu(1 ` 3600)
  ReservedStop_S := '2017/06/06 07:07:07'; // Lv`[\I(x[X)
  ReservedStop := StrToDateTime(ReservedStop_S); // Lv`[\I
  EveryDay := False; // ԑтɃLv`[\sB
  JPEGQuality := 70; // JPEG `ŕۑꍇ̉掿߂l(1`100)
  GIFOption := False; // GIF ŕۑRs[ꍇɁAɌFB

  { Lv`[摜ۑpfBNg CaptureData ݂邩mFB}
  Dir := ExtractFilePath(Application.ExeName) + 'CaptureData';
  if not DirectoryExists(Dir) then
    CreateDir(Dir);
  CaptureData := Dir + '\'; // Lv`[摜ۑpfBNg

  { AvP[V̊ep[^֌W̏ }
  Parameter1.Init; // Parameter1 Ăep[^t@C烍[hB

  if Parameter1.Count > 0 then // p[^̃[hɐꍇ
  begin
    Resident := Parameter1.VBools['Resident']; // ^XNg[ɏ풓B
    Notice := Parameter1.VBools['Notice']; // Lv`[摜ۑɂ̃t@C\B
    AutoSave := Parameter1.VBools['AutoSave']; // IɃLv`[摜ۑB
    DefaultGraphic := Parameter1['DefaultGraphic']; // Lv`[摜ۑ̃fBtHg̉摜̎
    HotKeyC := Parameter1['HotKeyC']; // Lv`[JnpO[ozbgL[
    HotKeyA := Parameter1['HotKeyA']; // ANeBuEBhE摜ۑpO[ozbgL[
    HotKeyS := Parameter1['HotKeyS']; // SXN[摜ۑpO[ozbgL[
    ReservedStart_S := Parameter1.VStrings['ReservedStart']; // Lv`[\Jn(x[X)
    ReservedStart := StrToDateTime(ReservedStart_S); // Lv`[\Jn
    ReservedStep := Parameter1['ReservedStep']; // Lv`[\̕bPʂ̕ۑԊu
    ReservedStop_S := Parameter1.VStrings['ReservedStop']; // Lv`[\I(x[X)
    ReservedStop := StrToDateTime(ReservedStop_S); // Lv`[\I
    EveryDay := Parameter1.VBools['EveryDay']; // ԑтɃLv`[\sB
    JPEGQuality := Parameter1['JPEGQuality']; // JPEG `ŕۑꍇ̉掿߂l(1`100)
    GIFOption := Parameter1.VBools['GIFOption']; // GIF ŕۑRs[ꍇɁAɌFB

  end
  else // p[^[hoȂꍇ
  begin
    Parameter1.Add('CaptureNݒt@C --- ̃t@ĆAҏWȂŉB');
    Parameter1.VBools['Resident'] := Resident; // ^XNg[ɏ풓B
    Parameter1.VBools['Notice'] := Notice; // Lv`[摜ۑɂ̃t@C\B
    Parameter1.VBools['AutoSave'] := AutoSave; // IɃLv`[摜ۑB
    Parameter1['DefaultGraphic'] := DefaultGraphic; // Lv`[摜ۑ̃fBtHg̉摜̎
    Parameter1['HotKeyC'] := HotKeyC; // Lv`[JnpO[ozbgL[
    Parameter1['HotKeyA'] := HotKeyA; // ANeBuEBhE摜ۑpO[ozbgL[
    Parameter1['HotKeyS'] := HotKeyS; // SXN[摜ۑpO[ozbgL[
    Parameter1.VStrings['ReservedStart'] := ReservedStart_S; // Lv`[\Jn(x[X)
    Parameter1['ReservedStep'] := ReservedStep; // Lv`[\̕bPʂ̕ۑԊu
    Parameter1.VStrings['ReservedStop'] := ReservedStop_S; // Lv`[\I(x[X)
    Parameter1.VBools['EveryDay'] := EveryDay; // ԑтɃLv`[\sB
    Parameter1['JPEGQuality'] := JPEGQuality; // JPEG `ŕۑꍇ̉掿߂l(1`100)
    Parameter1.VBools['GIFOption'] := GIFOption; // GIF ŕۑRs[ꍇɁAɌFB
    { vr[p̃f[^ }
    Parameter1['PLeft'] := 240;
    Parameter1['PTop'] := 235;
    Parameter1['PClientWidth'] := 446;
    Parameter1['PClientHeight'] := 267;
    Parameter1['PWindowState'] := Integer(wsNormal);
    Parameter1['PrintRatio'] := 100;
    Parameter1['PreviewRatio'] := 20;
    Parameter1['GraphicMode'] := 0; // gmMetafile
  end;

  if Resident then // ^XNgCɏ풓ꍇ
  begin
    // V UtilWindow 쐬Au[hLXgbZ[Ŵ݂󂯎点B
    uTaskBarRecreate := RegisterWindowMessage('TaskbarCreated');
    CreateTaskBarIcon;
    ShowWindow(Application.Handle, SW_HIDE);
    Application.ShowMainForm := False;
    AddHotKey('CAS'); // zbgL[o^
    // ^C}[̐ݒB(Lv`[\́A풓݂̂̋@\łE)
    InitTimer;
  end
  else
  begin
    if DoCapture = False then
    begin
      ClientWidth := 80;
      ClientHeight := 8;
      Tag := -1;
    end;
  end;
end;

procedure TFrameForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // WM_QUIT bZ[W󂯎鎞(ProcessMesageɔz)
  if Resident and (Application.Terminated or (Tag <> -1)) then
  begin
    ShowWindow(Application.Handle, SW_HIDE);
    Visible := False;
    Action := caNone;
  end;

  { AvP[V̊ep[^̕ۑ }
  // Parameter1.VBools['Resident'] := Resident; // ^XNg[ɏ풓B
  Parameter1.VBools['Notice'] := Notice; // Lv`[摜ۑɂ̃t@C\B
  Parameter1.VBools['AutoSave'] := AutoSave; // IɃLv`[摜ۑB
  Parameter1['DefaultGraphic'] := DefaultGraphic; // Lv`[摜ۑ̃fBtHg̉摜̎
  Parameter1['HotKeyC'] := HotKeyC; // Lv`[JnpO[ozbgL[
  Parameter1['HotKeyA'] := HotKeyA; // ANeBuEBhE摜ۑpO[ozbgL[
  Parameter1['HotKeyS'] := HotKeyS; // SXN[摜ۑpO[ozbgL[
  Parameter1.VStrings['ReservedStart'] := ReservedStart_S; // Lv`[\Jn(x[X)
  Parameter1['ReservedStep'] := ReservedStep; // Lv`[\̕bPʂ̕ۑԊu
  Parameter1.VStrings['ReservedStop'] := ReservedStop_S; // Lv`[\I(x[X)
  Parameter1.VBools['EveryDay'] := EveryDay; // ԑтɃLv`[\sB
  Parameter1['JPEGQuality'] := JPEGQuality; // JPEG `ŕۑꍇ̉掿߂l(1`100)
  Parameter1.VBools['GIFOption'] := GIFOption; // GIF ŕۑRs[ꍇɁAɌFB
  Parameter1.SaveToFile;

  { ݁AtH[ɕ\ĂC[WfBtHg̎ނ̉摜ŕۑB}
  if AutoSave then
    SaveFormImage(CaptureTime, DefaultGraphic);
end;

procedure TFrameForm.FormDestroy(Sender: TObject);
begin
  if Tag = -1 then
  begin
    if Resident then // ^XNgCɏ풓Ăꍇ
    begin
      DeleteTaskBarIcon; // gC̃ACR폜
      DeleteHotKey('CAS'); // zbgL[̓o^
    end;
  end;
end;

procedure TFrameForm.N1Click(Sender: TObject);
begin
  if Visible then
  Exit;

  if DoCapture then
    Show
  else
    Close;
end;

procedure TFrameForm.N3Click(Sender: TObject);
begin
  Exit;
end;

procedure TFrameForm.N5Click(Sender: TObject);
begin
  Tag := -1;
  Close;
end;

procedure TFrameForm.N6Click(Sender: TObject);
begin
  SettingForm := TSettingForm.Create(Self);

  SettingForm.ShowModal;

  SettingForm.Free;
end;

procedure TFrameForm.FormShow(Sender: TObject);
begin
  if Tag = -1 then
    Close;
end;

procedure TFrameForm.Help1Click(Sender: TObject);
var
  FileName: TFileName;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'Readme.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.About1Click(Sender: TObject);
begin
  ShellAbout(Handle, PChar(Application.Title),
             #13#10 + 'CaptureN  Version 1.2 Copyright (C) 2017 ` 2018 seizo',
             Application.Icon.Handle);
end;

procedure TFrameForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.Help2Click(Sender: TObject);
var
  FileName: TFileName;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'Readme.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.About2Click(Sender: TObject);
begin
  ShellAbout(Handle, PChar(Application.Title),
             #13#10 + 'CaptureN  Version 1.2 Copyright (C) 2017 ` 2018 seizo',
             Application.Icon.Handle);
end;

procedure TFrameForm.N9Click(Sender: TObject);
begin
  SettingForm := TSettingForm.Create(Self);

  SettingForm.ShowModal;

  SettingForm.Free;
end;

procedure TFrameForm.N11Click(Sender: TObject);
begin
  Exit;
end;

procedure TFrameForm.N13Click(Sender: TObject);
begin
  if Resident then
    Tag := -1;
  Close;
end;

procedure TFrameForm.PopupMenu2Popup(Sender: TObject);
begin
  if Resident then
  begin
    Close1.Visible := True;
    N20.Visible := True;
    N13.Caption := '풓';
  end
  else
  begin
    Close1.Visible := False;
    N20.Visible := False;
    N13.Caption := 'I';
  end;

  if Timer1.Enabled then
    N18.Caption := '\񒆎~'
  else
    N18.Caption := '\Jn';

  if Resident then
    N18.Visible := True
  else
    N18.Visible := False;
end;

procedure TFrameForm.Timer1Timer(Sender: TObject);
var
  RNow: TDateTime;
begin
  if Visible or (Timer1.Tag <> 0) then
    Exit;

  Timer1.Tag := 1;
  RNow := Now;
  if RNow > ReservedStop then // \͈͂߂ĂƂ
    Timer1.Enabled := False
  else if RNow >= ReservedStart then // \͈͂̂Ƃ
  begin
    SaveScreenImage(RNow, Rect(0, 0, Screen.Width - 1, Screen.Height - 1), DefaultGraphic);
    if Timer1.Interval <> Cardinal(ReservedStep * 1000) then
      Timer1.Interval := ReservedStep * 1000; // ~bPʂ̒l
  end
  else if RNow >= ReservedStart - VHour then // ꎞԈȓ̂Ƃ
  begin
    if Timer1.Interval <> Cardinal(ReservedStep * 1000) then
      Timer1.Interval := ReservedStep * 1000; // ~bPʂ̒l
  end
  else if RNow >= ReservedStart - VDay then // ꎞԈȏAȓ̂Ƃ
    Timer1.Interval := 60 * 1000 * 10 // 10
  else // ȏÔƂ
    Timer1.Enabled := False;
  Timer1.Tag := 0;
end;

procedure TFrameForm.N14Click(Sender: TObject);
var
  Dir: String;
begin
  Dir := ExtractFilePath(Application.ExeName) + 'CaptureData';
  ShellExecute(Handle, PChar('open'), PChar(Dir), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.N16Click(Sender: TObject);
var
  Dir: String;
begin
  Dir := ExtractFilePath(Application.ExeName) + 'CaptureData';
  ShellExecute(Handle, PChar('open'), PChar(Dir), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.Bitmap1Click(Sender: TObject);
begin
  SaveFormImage(CaptureTime, 0);
end;

procedure TFrameForm.JPEG1Click(Sender: TObject);
begin
  SaveFormImage(CaptureTime, 1);
end;

procedure TFrameForm.Metafile1Click(Sender: TObject);
begin
  SaveFormImage(CaptureTime, 3);
end;

procedure TFrameForm.N19Click(Sender: TObject);
begin
  Timer1.Tag := 0;
  if Timer1.Enabled then
    Timer1.Enabled := False
  else
    Timer1.Enabled := True;
end;

procedure TFrameForm.PopupMenu1Popup(Sender: TObject);
begin
  if Timer1.Enabled then
    N19.Caption := '\񒆎~'
  else
    N19.Caption := '\Jn';

  if Resident then
    N19.Enabled := True
  else
    N19.Enabled := False;
end;

procedure TFrameForm.N18Click(Sender: TObject);
begin
  Timer1.Tag := 0;
  if Timer1.Enabled then
    Timer1.Enabled := False
  else
    Timer1.Enabled := True;
end;

procedure TFrameForm.Bitmap2Click(Sender: TObject);
begin
  CopyFormImage(0);
end;

procedure TFrameForm.JPEG2Click(Sender: TObject);
begin
  CopyFormImage(1);
end;

procedure TFrameForm.Metafile2Click(Sender: TObject);
begin
  CopyFormImage(3);
end;

procedure TFrameForm.N22Click(Sender: TObject);
begin
  AmendForm := TAmendForm.Create(Self);

  AmendForm.ShowModal;

  AmendForm.Free;
end;

procedure TFrameForm.GIF1Click(Sender: TObject);
begin
  SaveFormImage(CaptureTime, 2);
end;

procedure TFrameForm.GIF2Click(Sender: TObject);
begin
  CopyFormImage(2);
end;

procedure TFrameForm.N2561Click(Sender: TObject);
begin
  TurboImage1.Reduce(rdcOctree);
end;

procedure TFrameForm.TurboImage1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DragPoint := Point(X, Y);
end;

procedure TFrameForm.TurboImage1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Shift <> [ssLeft]) or (TurboImage1.Picture.Graphic = Nil) then
    Exit;

  if (Abs(X - DragPoint.X) < Mouse.DragThreshold) and
     (Abs(Y - DragPoint.Y) < Mouse.DragThreshold) then
    Exit;

  DropBMPSource1.Bitmap := TurboImage1.Picture.Bitmap;
  DropBMPSource1.Execute; // Do it here - dragging from TurboImage1.
end;

procedure TFrameForm.T1Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TFrameForm.PrintPreview1Click(Sender: TObject);
begin
  if TurboImage1.Picture.Graphic = Nil then
    Exit;
  PreviewForm := TPreviewForm.Create(Self);
  PreviewForm.ShowModal;
  PreviewForm.Free;
end;

initialization
  CF_JFIF := RegisterClipboardFormat('JFIF');
  TPicture.RegisterClipboardFormat(CF_JFIF, TJPEGImage);
  RegisterClass(TJPEGImage);

  CF_GIF := RegisterClipboardFormat('GIF Image');
  TPicture.RegisterClipboardFormat(CF_GIF, TGIFImage);
  RegisterClass(TGIFImage);

end.
