unit Setting;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, ShlObj;

type
  TSettingForm = class(TForm)
    CheckBox1: TCheckBox;
    Button1: TButton;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    RadioGroup1: TRadioGroup;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    GroupBox1: TGroupBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    GroupBox2: TGroupBox;
    ComboBox1: TComboBox;
    Button2: TButton;
    TabSheet4: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox3: TGroupBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    GroupBox6: TGroupBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    GroupBox4: TGroupBox;
    ComboBox2: TComboBox;
    GroupBox5: TGroupBox;
    ComboBox3: TComboBox;
    Label4: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Label6: TLabel;
    Edit2: TEdit;
    UpDown1: TUpDown;
    Label7: TLabel;
    Edit3: TEdit;
    Label8: TLabel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    CheckBox16: TCheckBox;
    GroupBox7: TGroupBox;
    Edit4: TEdit;
    UpDown2: TUpDown;
    Label9: TLabel;
    Button6: TButton;
    GroupBox8: TGroupBox;
    CheckBox17: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  SettingForm: TSettingForm;

implementation

uses Frame;

{$R *.DFM}

procedure TSettingForm.FormShow(Sender: TObject);
var
  Key, Shift: Integer;
begin
  CheckBox1.Checked := FrameForm.Resident;
  CheckBox2.Checked := FrameForm.Notice;
  CheckBox3.Checked := FrameForm.AutoSave;
  RadioGroup1.ItemIndex := FrameForm.DefaultGraphic;
  UpDown2.Position := FrameForm.JPEGQuality;
  CheckBox17.Checked := FrameForm.GIFOption;

  Key := FrameForm.HotKeyC and $0000FFFF;
  if Key = 0 then
    ComboBox1.ItemIndex := 0
  else if (Key >= VK_F1) and (Key <= VK_F12) then
    ComboBox1.ItemIndex := Key - VK_F1 + 27
  else
    ComboBox1.ItemIndex := Key - Ord('A') + 1;
  Shift := FrameForm.HotKeyC shr 16;
  if (Shift and MOD_CONTROL) <> 0 then CheckBox4.Checked := True;
  if (Shift and MOD_SHIFT) <> 0 then CheckBox5.Checked := True;
  if (Shift and MOD_ALT) <> 0 then CheckBox6.Checked := True;
  if (Shift and MOD_WIN) <> 0 then CheckBox7.Checked := True;

  Key := FrameForm.HotKeyA and $0000FFFF;
  if Key = 0 then
    ComboBox2.ItemIndex := 0
  else if (Key >= VK_F1) and (Key <= VK_F12) then
    ComboBox2.ItemIndex := Key - VK_F1 + 27
  else
    ComboBox2.ItemIndex := Key - Ord('A') + 1;
  Shift := FrameForm.HotKeyA shr 16;
  if (Shift and MOD_CONTROL) <> 0 then CheckBox8.Checked := True;
  if (Shift and MOD_SHIFT) <> 0 then CheckBox9.Checked := True;
  if (Shift and MOD_ALT) <> 0 then CheckBox10.Checked := True;
  if (Shift and MOD_WIN) <> 0 then CheckBox11.Checked := True;

  Key := FrameForm.HotKeyS and $0000FFFF;
  if Key = 0 then
    ComboBox3.ItemIndex := 0
  else if (Key >= VK_F1) and (Key <= VK_F12) then
    ComboBox3.ItemIndex := Key - VK_F1 + 27
  else
    ComboBox3.ItemIndex := Key - Ord('A') + 1;
  Shift := FrameForm.HotKeyS shr 16;
  if (Shift and MOD_CONTROL) <> 0 then CheckBox12.Checked := True;
  if (Shift and MOD_SHIFT) <> 0 then CheckBox13.Checked := True;
  if (Shift and MOD_ALT) <> 0 then CheckBox14.Checked := True;
  if (Shift and MOD_WIN) <> 0 then CheckBox15.Checked := True;

  Edit1.Text := FrameForm.ReservedStart_S;
  UpDown1.Position := FrameForm.ReservedStep;
  Edit3.Text := FrameForm.ReservedStop_S;
  CheckBox16.Checked := FrameForm.EveryDay;
end;

procedure TSettingForm.Button1Click(Sender: TObject);
var
  Key, Shift: Integer;
  hc, ha, hs: Integer;
begin
  FrameForm.Parameter1.VBools['Resident'] := CheckBox1.Checked;

  if FrameForm.Resident <> CheckBox1.Checked then
  begin
    if CheckBox1.Checked then // ^XNgCɏ풓ꍇ
      FrameForm.Parameter1.CreateShortCut(CSIDL_STARTUP, 'CaptureN')
    else
      FrameForm.Parameter1.DeleteShortCut(CSIDL_STARTUP, 'CaptureN');
  end;

  if FrameForm.Resident <> FrameForm.Parameter1.VBools['Resident'] then
  begin
    if FrameForm.Resident then
      ShowMessage(#13#10 + '̐ݒ́AUCaptureN풓' + #13#10 + #13#10 +
                           '̋NLƂȂ܂B' + #13#10)
    else
      ShowMessage(#13#10 + '̐ݒ́AUCaptureNI' + #13#10 + #13#10 +
                           '̋NLƂȂ܂B' + #13#10);
  end;

  FrameForm.Notice := CheckBox2.Checked;
  FrameForm.AutoSave := CheckBox3.Checked;
  FrameForm.DefaultGraphic := RadioGroup1.ItemIndex;
  FrameForm.JPEGQuality := UpDown2.Position;
  FrameForm.GIFOption := CheckBox17.Checked;

  { HotKeyC p̒l߂B}
  Key := ComboBox1.ItemIndex;
  if Key > 26 then
    Key := Key - 27 + VK_F1
  else if Key > 0 then // 'A' ` 'Z'
    Key := Key - 1 + Ord('A');
  Shift := 0;
  if CheckBox4.Checked then Shift := Shift or MOD_CONTROL;
  if CheckBox5.Checked then Shift := Shift or MOD_SHIFT;
  if CheckBox6.Checked then Shift := Shift or MOD_ALT;
  if CheckBox7.Checked then Shift := Shift or MOD_WIN;
  hc := Key or (Shift shl 16);

  { HotKeyA p̒l߂B}
  Key := ComboBox2.ItemIndex;
  if Key > 26 then
    Key := Key - 27 + VK_F1
  else if Key > 0 then // 'A' ` 'Z'
    Key := Key - 1 + Ord('A');
  Shift := 0;
  if CheckBox8.Checked then Shift := Shift or MOD_CONTROL;
  if CheckBox9.Checked then Shift := Shift or MOD_SHIFT;
  if CheckBox10.Checked then Shift := Shift or MOD_ALT;
  if CheckBox11.Checked then Shift := Shift or MOD_WIN;
  ha := Key or (Shift shl 16);

  { HotKeyS p̒l߂B}
  Key := ComboBox3.ItemIndex;
  if Key > 26 then
    Key := Key - 27 + VK_F1
  else if Key > 0 then // 'A' ` 'Z'
    Key := Key - 1 + Ord('A');
  Shift := 0;
  if CheckBox12.Checked then Shift := Shift or MOD_CONTROL;
  if CheckBox13.Checked then Shift := Shift or MOD_SHIFT;
  if CheckBox14.Checked then Shift := Shift or MOD_ALT;
  if CheckBox15.Checked then Shift := Shift or MOD_WIN;
  hs := Key or (Shift shl 16);

  if ((hc <> 0) and (((hc and $FFFF0000) = 0) or ((hc and $0000FFFF) = 0))) or
     ((ha <> 0) and (((ha and $FFFF0000) = 0) or ((ha and $0000FFFF) = 0))) or
     ((hs <> 0) and (((hs and $FFFF0000) = 0) or ((hs and $0000FFFF) = 0))) then
    ShowMessage(#13#10 + 'zbgL[̎w肪słB' + #13#10 + #13#10 +
                'L[ƈʃL[̂ꂩ̃L[' + #13#10 + #13#10 +
                'Ȃɂ鎖́Ao܂B' + #13#10)
  else if ((hc <> 0) and (hc = ha)) or ((hc <> 0) and (hc = hs)) or ((ha <> 0) and (ha = hs)) then
    ShowMessage(#13#10 + 'zbgL[̐ݒ肪dĂ܂B' + #13#10 + #13#10 +
                'ezbgL[ɂ͏dȂL[蓖ĂĉB' + #13#10)
  else if FrameForm.Resident then // ݁A^XNg[ɏ풓ĂƂ
  begin
    if FrameForm.HotKeyC <> hc then // HotKeyC ύXꂽƂ
    begin
      FrameForm.HotKeyC := hc;
      FrameForm.DeleteHotKey('C'); // zbgL[̓o^
      FrameForm.AddHotKey('C'); // zbgL[o^
    end;

    if FrameForm.HotKeyA <> ha then // HotKeyA ύXꂽƂ
    begin
      FrameForm.HotKeyA := ha;
      FrameForm.DeleteHotKey('A'); // zbgL[̓o^
      FrameForm.AddHotKey('A'); // zbgL[o^
    end;

    if FrameForm.HotKeyS <> hs then // HotKeyS ύXꂽƂ
    begin
      FrameForm.HotKeyS := hs;
      FrameForm.DeleteHotKey('S'); // zbgL[̓o^
      FrameForm.AddHotKey('S'); // zbgL[o^
    end;
  end
  else
  begin
    FrameForm.HotKeyC := hc;
    FrameForm.HotKeyA := ha;
    FrameForm.HotKeyS := hs;
  end;

  if (FrameForm.ReservedStart_S <> Edit1.Text) or
     (FrameForm.ReservedStep <> UpDown1.Position) or
     (FrameForm.ReservedStop_S <> Edit3.Text) or
     (FrameForm.EveryDay <> CheckBox16.Checked) then
  begin
    if FrameForm.ReservedStart_S <> Edit1.Text then
    begin
      FrameForm.ReservedStart_S := Edit1.Text; // Lv`[\Jn(x[X)
      FrameForm.ReservedStart := StrToDateTime(FrameForm.ReservedStart_S);
    end;

    if FrameForm.ReservedStep <> UpDown1.Position then
      FrameForm.ReservedStep := UpDown1.Position; // Lv`[\̕bPʂ̕ۑԊu

    if FrameForm.ReservedStop_S <> Edit3.Text then
    begin
      FrameForm.ReservedStop_S := Edit3.Text; // Lv`[\I(x[X)
      FrameForm.ReservedStop := StrToDateTime(FrameForm.ReservedStop_S);
    end;

    if FrameForm.EveryDay <> CheckBox16.Checked then
      FrameForm.EveryDay := CheckBox16.Checked; // ԑтɃLv`[\sB

    if FrameForm.Resident then // ^C}[̐ݒB(Lv`[\́A풓݂̂̋@\)
      FrameForm.InitTimer;
  end;
end;

procedure TSettingForm.Button3Click(Sender: TObject);
begin
  ComboBox1.ItemIndex := 0;
  CheckBox4.Checked := False;
  CheckBox5.Checked := False;
  CheckBox6.Checked := False;
  CheckBox7.Checked := False;
end;

procedure TSettingForm.Button4Click(Sender: TObject);
begin
  ComboBox2.ItemIndex := 0;
  CheckBox8.Checked := False;
  CheckBox9.Checked := False;
  CheckBox10.Checked := False;
  CheckBox11.Checked := False;
end;

procedure TSettingForm.Button5Click(Sender: TObject);
begin
  ComboBox3.ItemIndex := 0;
  CheckBox12.Checked := False;
  CheckBox13.Checked := False;
  CheckBox14.Checked := False;
  CheckBox15.Checked := False;
end;

procedure TSettingForm.Button6Click(Sender: TObject);
begin
  Edit1.Text := FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);
  Edit3.Text := Edit1.Text;
end;

end.
